# coding: utf-8

"""
InfluxDB OSS API Service.

The InfluxDB v2 API provides a programmatic interface for all interactions with InfluxDB. Access the InfluxDB API using the `/api/v2/` endpoint.   # noqa: E501

OpenAPI spec version: 2.0.0
Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401


class Field(object):
    """NOTE: This class is auto generated by OpenAPI Generator.

    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'value': 'str',
        'type': 'str',
        'alias': 'str',
        'args': 'list[Field]'
    }

    attribute_map = {
        'value': 'value',
        'type': 'type',
        'alias': 'alias',
        'args': 'args'
    }

    def __init__(self, value=None, type=None, alias=None, args=None):  # noqa: E501,D401,D403
        """Field - a model defined in OpenAPI."""  # noqa: E501
        self._value = None
        self._type = None
        self._alias = None
        self._args = None
        self.discriminator = None

        if value is not None:
            self.value = value
        if type is not None:
            self.type = type
        if alias is not None:
            self.alias = alias
        if args is not None:
            self.args = args

    @property
    def value(self):
        """Get the value of this Field.

        value is the value of the field.  Meaning of the value is implied by the `type` key

        :return: The value of this Field.
        :rtype: str
        """  # noqa: E501
        return self._value

    @value.setter
    def value(self, value):
        """Set the value of this Field.

        value is the value of the field.  Meaning of the value is implied by the `type` key

        :param value: The value of this Field.
        :type: str
        """  # noqa: E501
        self._value = value

    @property
    def type(self):
        """Get the type of this Field.

        `type` describes the field type. `func` is a function. `field` is a field reference.

        :return: The type of this Field.
        :rtype: str
        """  # noqa: E501
        return self._type

    @type.setter
    def type(self, type):
        """Set the type of this Field.

        `type` describes the field type. `func` is a function. `field` is a field reference.

        :param type: The type of this Field.
        :type: str
        """  # noqa: E501
        self._type = type

    @property
    def alias(self):
        """Get the alias of this Field.

        Alias overrides the field name in the returned response.  Applies only if type is `func`

        :return: The alias of this Field.
        :rtype: str
        """  # noqa: E501
        return self._alias

    @alias.setter
    def alias(self, alias):
        """Set the alias of this Field.

        Alias overrides the field name in the returned response.  Applies only if type is `func`

        :param alias: The alias of this Field.
        :type: str
        """  # noqa: E501
        self._alias = alias

    @property
    def args(self):
        """Get the args of this Field.

        Args are the arguments to the function

        :return: The args of this Field.
        :rtype: list[Field]
        """  # noqa: E501
        return self._args

    @args.setter
    def args(self, args):
        """Set the args of this Field.

        Args are the arguments to the function

        :param args: The args of this Field.
        :type: list[Field]
        """  # noqa: E501
        self._args = args

    def to_dict(self):
        """Return the model properties as a dict."""
        result = {}

        for attr, _ in self.openapi_types.items():
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Return the string representation of the model."""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`."""
        return self.to_str()

    def __eq__(self, other):
        """Return true if both objects are equal."""
        if not isinstance(other, Field):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Return true if both objects are not equal."""
        return not self == other
