# coding: utf-8

"""
InfluxDB OSS API Service.

The InfluxDB v2 API provides a programmatic interface for all interactions with InfluxDB. Access the InfluxDB API using the `/api/v2/` endpoint.   # noqa: E501

OpenAPI spec version: 2.0.0
Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

from influxdb_client.domain.expression import Expression


class FunctionExpression(Expression):
    """NOTE: This class is auto generated by OpenAPI Generator.

    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'type': 'str',
        'params': 'list[ModelProperty]',
        'body': 'Node'
    }

    attribute_map = {
        'type': 'type',
        'params': 'params',
        'body': 'body'
    }

    def __init__(self, type=None, params=None, body=None):  # noqa: E501,D401,D403
        """FunctionExpression - a model defined in OpenAPI."""  # noqa: E501
        Expression.__init__(self)  # noqa: E501

        self._type = None
        self._params = None
        self._body = None
        self.discriminator = None

        if type is not None:
            self.type = type
        if params is not None:
            self.params = params
        if body is not None:
            self.body = body

    @property
    def type(self):
        """Get the type of this FunctionExpression.

        Type of AST node

        :return: The type of this FunctionExpression.
        :rtype: str
        """  # noqa: E501
        return self._type

    @type.setter
    def type(self, type):
        """Set the type of this FunctionExpression.

        Type of AST node

        :param type: The type of this FunctionExpression.
        :type: str
        """  # noqa: E501
        self._type = type

    @property
    def params(self):
        """Get the params of this FunctionExpression.

        Function parameters

        :return: The params of this FunctionExpression.
        :rtype: list[ModelProperty]
        """  # noqa: E501
        return self._params

    @params.setter
    def params(self, params):
        """Set the params of this FunctionExpression.

        Function parameters

        :param params: The params of this FunctionExpression.
        :type: list[ModelProperty]
        """  # noqa: E501
        self._params = params

    @property
    def body(self):
        """Get the body of this FunctionExpression.

        :return: The body of this FunctionExpression.
        :rtype: Node
        """  # noqa: E501
        return self._body

    @body.setter
    def body(self, body):
        """Set the body of this FunctionExpression.

        :param body: The body of this FunctionExpression.
        :type: Node
        """  # noqa: E501
        self._body = body

    def to_dict(self):
        """Return the model properties as a dict."""
        result = {}

        for attr, _ in self.openapi_types.items():
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Return the string representation of the model."""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`."""
        return self.to_str()

    def __eq__(self, other):
        """Return true if both objects are equal."""
        if not isinstance(other, FunctionExpression):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Return true if both objects are not equal."""
        return not self == other
