# coding: utf-8

"""
InfluxDB OSS API Service.

The InfluxDB v2 API provides a programmatic interface for all interactions with InfluxDB. Access the InfluxDB API using the `/api/v2/` endpoint.   # noqa: E501

OpenAPI spec version: 2.0.0
Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401


class HealthCheck(object):
    """NOTE: This class is auto generated by OpenAPI Generator.

    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'name': 'str',
        'message': 'str',
        'checks': 'list[HealthCheck]',
        'status': 'str',
        'version': 'str',
        'commit': 'str'
    }

    attribute_map = {
        'name': 'name',
        'message': 'message',
        'checks': 'checks',
        'status': 'status',
        'version': 'version',
        'commit': 'commit'
    }

    def __init__(self, name=None, message=None, checks=None, status=None, version=None, commit=None):  # noqa: E501,D401,D403
        """HealthCheck - a model defined in OpenAPI."""  # noqa: E501
        self._name = None
        self._message = None
        self._checks = None
        self._status = None
        self._version = None
        self._commit = None
        self.discriminator = None

        self.name = name
        if message is not None:
            self.message = message
        if checks is not None:
            self.checks = checks
        self.status = status
        if version is not None:
            self.version = version
        if commit is not None:
            self.commit = commit

    @property
    def name(self):
        """Get the name of this HealthCheck.

        :return: The name of this HealthCheck.
        :rtype: str
        """  # noqa: E501
        return self._name

    @name.setter
    def name(self, name):
        """Set the name of this HealthCheck.

        :param name: The name of this HealthCheck.
        :type: str
        """  # noqa: E501
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501
        self._name = name

    @property
    def message(self):
        """Get the message of this HealthCheck.

        :return: The message of this HealthCheck.
        :rtype: str
        """  # noqa: E501
        return self._message

    @message.setter
    def message(self, message):
        """Set the message of this HealthCheck.

        :param message: The message of this HealthCheck.
        :type: str
        """  # noqa: E501
        self._message = message

    @property
    def checks(self):
        """Get the checks of this HealthCheck.

        :return: The checks of this HealthCheck.
        :rtype: list[HealthCheck]
        """  # noqa: E501
        return self._checks

    @checks.setter
    def checks(self, checks):
        """Set the checks of this HealthCheck.

        :param checks: The checks of this HealthCheck.
        :type: list[HealthCheck]
        """  # noqa: E501
        self._checks = checks

    @property
    def status(self):
        """Get the status of this HealthCheck.

        :return: The status of this HealthCheck.
        :rtype: str
        """  # noqa: E501
        return self._status

    @status.setter
    def status(self, status):
        """Set the status of this HealthCheck.

        :param status: The status of this HealthCheck.
        :type: str
        """  # noqa: E501
        if status is None:
            raise ValueError("Invalid value for `status`, must not be `None`")  # noqa: E501
        self._status = status

    @property
    def version(self):
        """Get the version of this HealthCheck.

        :return: The version of this HealthCheck.
        :rtype: str
        """  # noqa: E501
        return self._version

    @version.setter
    def version(self, version):
        """Set the version of this HealthCheck.

        :param version: The version of this HealthCheck.
        :type: str
        """  # noqa: E501
        self._version = version

    @property
    def commit(self):
        """Get the commit of this HealthCheck.

        :return: The commit of this HealthCheck.
        :rtype: str
        """  # noqa: E501
        return self._commit

    @commit.setter
    def commit(self, commit):
        """Set the commit of this HealthCheck.

        :param commit: The commit of this HealthCheck.
        :type: str
        """  # noqa: E501
        self._commit = commit

    def to_dict(self):
        """Return the model properties as a dict."""
        result = {}

        for attr, _ in self.openapi_types.items():
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Return the string representation of the model."""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`."""
        return self.to_str()

    def __eq__(self, other):
        """Return true if both objects are equal."""
        if not isinstance(other, HealthCheck):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Return true if both objects are not equal."""
        return not self == other
