# coding: utf-8

"""
InfluxDB OSS API Service.

The InfluxDB v2 API provides a programmatic interface for all interactions with InfluxDB. Access the InfluxDB API using the `/api/v2/` endpoint.   # noqa: E501

OpenAPI spec version: 2.0.0
Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401


class Package(object):
    """NOTE: This class is auto generated by OpenAPI Generator.

    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'type': 'str',
        'path': 'str',
        'package': 'str',
        'files': 'list[File]'
    }

    attribute_map = {
        'type': 'type',
        'path': 'path',
        'package': 'package',
        'files': 'files'
    }

    def __init__(self, type=None, path=None, package=None, files=None):  # noqa: E501,D401,D403
        """Package - a model defined in OpenAPI."""  # noqa: E501
        self._type = None
        self._path = None
        self._package = None
        self._files = None
        self.discriminator = None

        if type is not None:
            self.type = type
        if path is not None:
            self.path = path
        if package is not None:
            self.package = package
        if files is not None:
            self.files = files

    @property
    def type(self):
        """Get the type of this Package.

        Type of AST node

        :return: The type of this Package.
        :rtype: str
        """  # noqa: E501
        return self._type

    @type.setter
    def type(self, type):
        """Set the type of this Package.

        Type of AST node

        :param type: The type of this Package.
        :type: str
        """  # noqa: E501
        self._type = type

    @property
    def path(self):
        """Get the path of this Package.

        Package import path

        :return: The path of this Package.
        :rtype: str
        """  # noqa: E501
        return self._path

    @path.setter
    def path(self, path):
        """Set the path of this Package.

        Package import path

        :param path: The path of this Package.
        :type: str
        """  # noqa: E501
        self._path = path

    @property
    def package(self):
        """Get the package of this Package.

        Package name

        :return: The package of this Package.
        :rtype: str
        """  # noqa: E501
        return self._package

    @package.setter
    def package(self, package):
        """Set the package of this Package.

        Package name

        :param package: The package of this Package.
        :type: str
        """  # noqa: E501
        self._package = package

    @property
    def files(self):
        """Get the files of this Package.

        Package files

        :return: The files of this Package.
        :rtype: list[File]
        """  # noqa: E501
        return self._files

    @files.setter
    def files(self, files):
        """Set the files of this Package.

        Package files

        :param files: The files of this Package.
        :type: list[File]
        """  # noqa: E501
        self._files = files

    def to_dict(self):
        """Return the model properties as a dict."""
        result = {}

        for attr, _ in self.openapi_types.items():
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Return the string representation of the model."""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`."""
        return self.to_str()

    def __eq__(self, other):
        """Return true if both objects are equal."""
        if not isinstance(other, Package):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Return true if both objects are not equal."""
        return not self == other
