# coding: utf-8

"""
InfluxDB OSS API Service.

The InfluxDB v2 API provides a programmatic interface for all interactions with InfluxDB. Access the InfluxDB API using the `/api/v2/` endpoint.   # noqa: E501

OpenAPI spec version: 2.0.0
Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401


class RemoteConnectionUpdateRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.

    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'name': 'str',
        'description': 'str',
        'remote_url': 'str',
        'remote_api_token': 'str',
        'remote_org_id': 'str',
        'allow_insecure_tls': 'bool'
    }

    attribute_map = {
        'name': 'name',
        'description': 'description',
        'remote_url': 'remoteURL',
        'remote_api_token': 'remoteAPIToken',
        'remote_org_id': 'remoteOrgID',
        'allow_insecure_tls': 'allowInsecureTLS'
    }

    def __init__(self, name=None, description=None, remote_url=None, remote_api_token=None, remote_org_id=None, allow_insecure_tls=False):  # noqa: E501,D401,D403
        """RemoteConnectionUpdateRequest - a model defined in OpenAPI."""  # noqa: E501
        self._name = None
        self._description = None
        self._remote_url = None
        self._remote_api_token = None
        self._remote_org_id = None
        self._allow_insecure_tls = None
        self.discriminator = None

        if name is not None:
            self.name = name
        if description is not None:
            self.description = description
        if remote_url is not None:
            self.remote_url = remote_url
        if remote_api_token is not None:
            self.remote_api_token = remote_api_token
        if remote_org_id is not None:
            self.remote_org_id = remote_org_id
        if allow_insecure_tls is not None:
            self.allow_insecure_tls = allow_insecure_tls

    @property
    def name(self):
        """Get the name of this RemoteConnectionUpdateRequest.

        :return: The name of this RemoteConnectionUpdateRequest.
        :rtype: str
        """  # noqa: E501
        return self._name

    @name.setter
    def name(self, name):
        """Set the name of this RemoteConnectionUpdateRequest.

        :param name: The name of this RemoteConnectionUpdateRequest.
        :type: str
        """  # noqa: E501
        self._name = name

    @property
    def description(self):
        """Get the description of this RemoteConnectionUpdateRequest.

        :return: The description of this RemoteConnectionUpdateRequest.
        :rtype: str
        """  # noqa: E501
        return self._description

    @description.setter
    def description(self, description):
        """Set the description of this RemoteConnectionUpdateRequest.

        :param description: The description of this RemoteConnectionUpdateRequest.
        :type: str
        """  # noqa: E501
        self._description = description

    @property
    def remote_url(self):
        """Get the remote_url of this RemoteConnectionUpdateRequest.

        :return: The remote_url of this RemoteConnectionUpdateRequest.
        :rtype: str
        """  # noqa: E501
        return self._remote_url

    @remote_url.setter
    def remote_url(self, remote_url):
        """Set the remote_url of this RemoteConnectionUpdateRequest.

        :param remote_url: The remote_url of this RemoteConnectionUpdateRequest.
        :type: str
        """  # noqa: E501
        self._remote_url = remote_url

    @property
    def remote_api_token(self):
        """Get the remote_api_token of this RemoteConnectionUpdateRequest.

        :return: The remote_api_token of this RemoteConnectionUpdateRequest.
        :rtype: str
        """  # noqa: E501
        return self._remote_api_token

    @remote_api_token.setter
    def remote_api_token(self, remote_api_token):
        """Set the remote_api_token of this RemoteConnectionUpdateRequest.

        :param remote_api_token: The remote_api_token of this RemoteConnectionUpdateRequest.
        :type: str
        """  # noqa: E501
        self._remote_api_token = remote_api_token

    @property
    def remote_org_id(self):
        """Get the remote_org_id of this RemoteConnectionUpdateRequest.

        :return: The remote_org_id of this RemoteConnectionUpdateRequest.
        :rtype: str
        """  # noqa: E501
        return self._remote_org_id

    @remote_org_id.setter
    def remote_org_id(self, remote_org_id):
        """Set the remote_org_id of this RemoteConnectionUpdateRequest.

        :param remote_org_id: The remote_org_id of this RemoteConnectionUpdateRequest.
        :type: str
        """  # noqa: E501
        self._remote_org_id = remote_org_id

    @property
    def allow_insecure_tls(self):
        """Get the allow_insecure_tls of this RemoteConnectionUpdateRequest.

        :return: The allow_insecure_tls of this RemoteConnectionUpdateRequest.
        :rtype: bool
        """  # noqa: E501
        return self._allow_insecure_tls

    @allow_insecure_tls.setter
    def allow_insecure_tls(self, allow_insecure_tls):
        """Set the allow_insecure_tls of this RemoteConnectionUpdateRequest.

        :param allow_insecure_tls: The allow_insecure_tls of this RemoteConnectionUpdateRequest.
        :type: bool
        """  # noqa: E501
        self._allow_insecure_tls = allow_insecure_tls

    def to_dict(self):
        """Return the model properties as a dict."""
        result = {}

        for attr, _ in self.openapi_types.items():
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Return the string representation of the model."""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`."""
        return self.to_str()

    def __eq__(self, other):
        """Return true if both objects are equal."""
        if not isinstance(other, RemoteConnectionUpdateRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Return true if both objects are not equal."""
        return not self == other
